/*
	Reverse V1.1, reverses a file
	Source code put in public domain by Didier Stevens, no Copyright
	http://didierstevens.com
	Use at your own risk

	Shortcommings, or todo's ;-)
	- no pipe support (file redirection)
	- file must fit in memory
*/

#include <stdio.h>
#include <sys/stat.h>
#include <malloc.h>

main(int argc, char **argv)
{
	FILE *fIn, *fOut;
	struct stat statFile;
	void *pBuffer;
	char *pchrFirst, *pchrSecond;
	char chrTmp;

	if (argc != 3)
	{
		fprintf(stderr, "Usage: reverse file-in file-out\n"
							 "Reverse V1.1, reverses a file\n"
							 "Source code put in the public domain by Didier Stevens, no Copyright\n"
							 "Use at your own risk\n"
							 "http://didierstevens.com\n");
		return -1;
	}


	if (stat(argv[1], &statFile) != 0)
	{
		fprintf(stderr, "error opening file %s\n", argv[1]);
		return -1;
	}

	if ((pBuffer = malloc(statFile.st_size)) == NULL)
	{
		fprintf (stderr, "file %s is too large %ld\n", argv[1], statFile.st_size);
		return -1;
	}

	if ((fIn = fopen(argv[1], "rb")) == NULL)
	{
		fprintf(stderr, "error opening file %s\n", argv[1]);
		return -1;
	}

	if (fread(pBuffer, statFile.st_size, 1, fIn) != 1)
	{
		fprintf(stderr, "error reading file %s\n", argv[1]);
		fclose (fIn);
		free (pBuffer);
		return -1;
	}

	fclose (fIn);

	pchrFirst = (char *) pBuffer;
	pchrSecond = pchrFirst + statFile.st_size - 1;

	while (pchrSecond - pchrFirst > 0)
	{
		chrTmp = *pchrFirst;
		*pchrFirst++ = *pchrSecond;
		*pchrSecond-- = chrTmp;
	}

	if ((fOut = fopen(argv[2], "wb")) == NULL)
	{
		fprintf(stderr, "error opening file %s\n", argv[2]);
		free (pBuffer);
		return -1;
	}

	if (fwrite(pBuffer, statFile.st_size, 1, fOut) != 1)
	{
		fprintf(stderr, "error writing file %s\n", argv[2]);
		free (pBuffer);
		fclose (fOut);
		return -1;
	}

	fclose (fOut);
	free (pBuffer);

	return 0;
}